
// ALL GCM notifications come through here.
function onNotificationGCM(e) {
    console.log('EVENT -> RECEIVED:' + e.event + '');
    alert('EVENT -> RECEIVED:' + e.event + '');
    switch( e.event )
    {
        case 'registered':
            if ( e.regid.length > 0 )
            {
                console.log('REGISTERED with GCM Server -> REGID:' + e.regid + "");

                //call back to web service in Angular.
                //This works for me because in my code I have a factory called
                //      PushProcessingService with method registerID
                var elem = angular.element(document.querySelector('[ng-app]'));
                var injector = elem.injector();
                // var myService = injector.get('PushProcessingService');
                // myService.registerID(e.regid);
                // console.warn('Registration ID: ' + e.regid);
                // console.warn('Registration ID successfuly send to DB');
                var Service = injector.get('Service');
                Service.addAndroidPushId(e.regid).then(function(response){
                    // if (response.data.Result) {
                    if(response.data){
                        console.info('NOTIFY  Registration succeeded');
                    } else {
                        console.error('NOTIFY  Registration failed');
                    }
                });
            }
            break;

        case 'message':
            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground)
            {
                // alert("foreground");
                //we're using the app when a message is received.
                console.log('--INLINE NOTIFICATION--' + '');

                // if the notification contains a soundname, play it.
                //var my_media = new Media("/android_asset/www/"+e.soundname);
                //my_media.play();
                var elem = angular.element(document.querySelector('[ng-app]'));
                var injector = elem.injector();

                var $cordovaDialogs = injector.get('$cordovaDialogs');
                var state = injector.get('$state');

                if(state.current.name != 'app.game') {
                    if(e.payload.whatToDo == 1) {

                        $cordovaDialogs.confirm('Ein neuer Spielstand liegt im Spiel ... vor. Wollen sie zu diesem Match wechseln?',function (buttonIndex) {
                          if(buttonIndex == 1) {

                            console.log(state);
                            state.go('app.game',{gameid:e.payload.gameid});
                            // alert("switch to game : " + e.payload.gameid);
                          }
                        }, 'Match', ['Ja','Nein']);
                    }
                    else if(e.payload.whatToDo == 2) {

                        $cordovaDialogs.alert('Das hier sind News die gerade über den Push Nachrichten Dienst empfangen wurden. Wir sollen bitte alle Lauf und Fußball Schuhe zum training mitnehmen und das Training findet nur für die KM statt.',function (buttonIndex) {
                        }, 'News', 'OK');
                    }
                }
                // alert(e.payload.message);
            }
            else
            {
                // alert(e.coldstart);

                var elem = angular.element(document.querySelector('[ng-app]'));
                var injector = elem.injector();

                if(e.payload.whatToDo == 1) {
                    var state = injector.get('$state');
                    state.go('app.game',{gameid:e.payload.gameid});
                    // alert("switch to game : " + e.payload.gameid);
                }

                // otherwise we were launched because the user touched a notification in the notification tray.
                if (e.coldstart)
                    console.log('--COLDSTART NOTIFICATION--' + '');
                else
                    console.log('--BACKGROUND NOTIFICATION--' + '');

                // direct user here:
                window.location = "#/tab/featured";
            }

            console.log('MESSAGE -> MSG: ' + e.payload.message + '');
            console.log('MESSAGE: '+ JSON.stringify(e.payload));
            break;

        case 'error':
            console.log('ERROR -> MSG:' + e.msg + '');
            break;

        default:
            console.log('EVENT -> Unknown, an event was received and we do not know what it is');
            break;
    }
}


//PUSHWOOSH//
// function initPushwoosh()
// {
//     var pushNotification = window.plugins.pushNotification;

//     //set push notifications handler
//     document.addEventListener('push-notification', function(event) {
//         var title = event.notification.title;
//         var userData = event.notification.userdata;

//         if(typeof(userData) != "undefined") {
//             console.warn('user data: ' + JSON.stringify(userData));
//         }

//         // navigator.notification.alert(title);
//         alert(title);
//         alert(userData);
//     });

//     //initialize Pushwoosh with projectid: "GOOGLE_PROJECT_ID", appid : "PUSHWOOSH_APP_ID". This will trigger all pending push notifications on start.
//     pushNotification.onDeviceReady({ projectid: "symbolic-axe-583", appid : "B9B20-9F817" });

//     //register for pushes
//     pushNotification.registerDevice(
//         function(status) {
//             var pushToken = status;
//             console.warn('push token: ' + pushToken);
//         },
//         function(status) {
//             console.warn(JSON.stringify(['failed to register ', status]));
//         }
//     );
// }

// document.addEventListener("deviceready", initPushwoosh, true);
