var debug = false;
var anchor = null;
// Ionic Starter App, v0.9.20

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.services', 'starter.directives','starter.controllers', 'ngCordova.plugins.dialogs'])

  .constant('$ionicLoadingConfig', {
    content: 'Daten werden geladen ...'
  })
// .run(function($ionicPlatform, $ionicPopup, PushProcessingService, $cordovaPush) {
 .run(function($ionicPlatform) {

  //run once for the app
  // PushProcessingService.initialize();
  $ionicPlatform.ready(function() {
    if(window.StatusBar) {
      // Set the statusbar to use the default style, tweak this to
      // remove the status bar on iOS or change it to use white instead of dark colors.
      console.log("ja ich probiere die statusbar auszublenden");
      StatusBar.styleDefault();
    }
    // if(window.StatusBar) {
    //   StatusBar.styleDefault();
    // }
    // if(navigator.connection.type == Connection.NONE){
    //   $ionicPopup.alert({
    //     title: 'Keine Internetverbindung!',
    //     subTitle: 'lalalal alala =( ',
    //     template: 'Die App benötigt Internetverbindung!'
    //   })
    //   .then(function(res) {
    //     console.log('Thank you for not eating my delicious ice cream cone');
    //   });
    // }else{
    // }
    // StatusBar.hide();
    /*Back Button Handling*/
    // $ionicPlatform.onHardwareBackButton(function () {
    //    e.preventDefault();
    // });

    // ionic.Platform.registerBackButtonAction(function () {
    // }, 10);
    // $ionicPlatform.onHardwareBackButton(function () {
    // });

    if(debug === false) {
      if(typeof analytics !== "undefined") {
          analytics.startTrackerWithId("UA-42822204-3");
      } else {
          console.log("Google Analytics Unavailable");
      }
    }


    $ionicPlatform.detect();
    // ionic.Platform.detect();
    ionic.Platform.fullScreen();

    // var androidConfig = {
    //   "senderID":"306528130620",
    //   "ecb":"onNotificationGCM"
    // };

    // var iosConfig = {
    //   "badge":"true",
    //   "sound":"true",
    //   "alert":"true",
    //   "ecb":"onNotificationAPN"
    // };

    // $cordovaPush.register(androidConfig).then(function(result) {
    //     // Success!
    //     console.warn('Successfuly Push registration');
    //     console.log(result);
    // }, function(err) {
    //     // An error occured. Show a message to the user
    // });

    // $cordovaPush.register(iosConfig).then(function(result) {
    //     // Success!

    //     console.warn('Successfuly Push registration');
    //     console.log(result);
    // }, function(err) {
    //     // An error occured. Show a message to the user
    // });


    // $cordovaPush.unregister(options).then(function(result) {
    //     // Success!
    // }, function(err) {
    //     // An error occured. Show a message to the user
    // });

    // // iOS only
    // $cordovaPush.setBadgeNumber(2).then(function(result) {
    //     // Success!
    // }, function(err) {
    //     // An error occured. Show a message to the user
    // });

    // PushProcessingService.initialize();
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/app.html",
      controller: 'AppCtrl'
    })

    .state('app.news', {
      url: "/news",
      views: {
        'menuContent' :{
          templateUrl: "templates/news.html",
          controller: 'NewsCtrl'
        }
      }
    })

    .state('app.home', {
      url: "/home",
      views: {
        'menuContent' :{
          templateUrl: "templates/home.html",
          controller: 'HomeCtrl'
        }
      }
    })

    .state('app.cal', {
      url: "/cal",
      views: {
        'menuContent' :{
          templateUrl: "templates/cal.html",
          controller: 'CalCtrl'
        }
      }
    })

    .state('app.info', {
      url: "/info/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/info.html",
          controller: 'InfoCtrl'
        }
      }
    })

    .state('app.goals', {
      url: "/goals/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/goals.html",
          controller: 'GoalCtrl'
        }
      }
    })

    .state('app.assists', {
      url: "/assists/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/assists.html",
          controller: 'AssistCtrl'
        }
      }
    })

    .state('app.trainingsbeteiligung', {
      url: "/trainingsbeteiligung/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/trainingsbeteiligung.html",
          controller: 'TrainingsbeteiligungCtrl'
        }
      }
    })

    // .state('app.gameplan', {
    //   url: "/gameplan/:half/:what/:team",
    //   views: {
    //     'menuContent' :{
    //       templateUrl: "templates/gameplan.html",
    //       controller: 'GameplanCtrl'
    //     }
    //   }
    // })

    .state('app.gameplan', {
      url: "/gameplan/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/gameplan.html",
          controller: 'GameplanCtrl'
        }
      }
    })

    .state('app.gameplanselection', {
      url: "/gameplanselection/:team",
      views: {
        'menuContent' :{
          templateUrl: "templates/gameplanselection.html",
          controller: 'GameplanSelectionCtrl'
        }
      }
    })

    .state('app.game', {
      url: "/game/:gameid",
      views: {
        'menuContent' :{
          templateUrl: "templates/game.html",
          controller: 'GameCtrl'
        }
      }
    })

    .state('app.player', {
      url: "/player/:playerid",
      views: {
        'menuContent' :{
          templateUrl: "templates/player.html",
          controller: 'PlayerCtrl'
        }
      }
    })

    .state('app.training', {
      url: "/training/:trainingid",
      views: {
        'menuContent' :{
          templateUrl: "templates/training.html",
          controller: 'TrainingCtrl'
        }
      }
    })

    .state('app.event', {
      url: "/event/:eventid",
      views: {
        'menuContent' :{
          templateUrl: "templates/event.html",
          controller: 'EventCtrl'
        }
      }
    })
    .state('app.settings', {
      url: "/settings",
      views: {
        'menuContent' :{
          templateUrl: "templates/settings.html",
          controller: 'SettingsCtrl'
        }
      }
    })
    .state('app.help', {
      url: "/help",
      views: {
        'menuContent' :{
          templateUrl: "templates/help.html",
          controller: 'HelpCtrl'
        }
      }
    });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});
